import mongoose from "mongoose";
import Users from "../model/users.model.js";
import agentTracking from "../model/agentTracking.model.js";
import agentData from "../model/Agent.data.js";
import AgentPaymentdetails from "../model/AgentPaymentDetails.js";
import order from "../model/order.model.js";
import agentpaymentotp from "../model/AgentPaymentSettlementotp.js";
import dotenv from 'dotenv';
import axios from "axios";
import pkg from 'body-parser';
const { json } = pkg;
import SibApiV3Sdk from 'sib-api-v3-sdk';
import Paymentdetails from "../model/AgentPaymentDetails.js";






// import mongoose from "mongoose";

dotenv.config();
const apiKey = process.env.APIKEY;
// const apiKey = 'rzp_live_c8RouP3eKq6D1C';
const apiSecret = process.env.APISECRET;
// const apiSecret = '63WBO3yFwX6gHymOiypMjXm7';

const ObjectId = mongoose.Types.ObjectId;
//api for get all the data
export const getAgent_data = async (req, res) => {
    try {
        const agent_data = await Users.find({ usertype: "agent" });
        for (const agent of agent_data) {
            // console.log("The agent is", agent);
            const selected_agent = agent._id;
            console.log("The selected agent is", selected_agent);
            var today_Date = new Date().toISOString().slice(0, 10); // "2025-02-10"
            var [year, month, day] = today_Date.split("-");
            var formattedDate = `${day}-${month}-${year}`; // "10-02-25"
            console.log("the formated date is",formattedDate);
             console.log("the date is",today_Date);
            const today = new Date();
            const startOfDay = new Date(today.setUTCHours(0, 0, 0, 0));  // 2025-02-10T00:00:00.000Z
            const endOfDay = new Date(today.setUTCHours(23, 59, 59, 999));


            // Await works here because it's inside an async function
            const todayOrders = await order.find({
                agent_id: selected_agent,
                schedule_date:formattedDate,
                status: { $in: ["processed", "Pickup Completed", "reversed"] }
            });
            
            const createdAt = new Date().toDateString();
            console.log("the order data is", todayOrders);
            if (todayOrders.length > 0) {
              const agentId = todayOrders[0].agent_id;
              console.log("The agent ID is", agentId);
          
              // Fetch the agent's data from the Users table
              const agent_data = await Users.findOne({ _id: agentId });
          
              var today_Date = new Date().toISOString().slice(0, 10);
              var [year, month, day] = today_Date.split("-");
              var db_date = `${day}-${month}-${year}`; // Keep this unchanged for new entry
              const Daily_wages = agent_data.Daily_wages;
              const agent_name = agent_data.name;
          
              console.log("The daily wages is", Daily_wages);
          
              // Check for duplicate entries
              const check_duplicate_entry = await agentData.find({
                  agent_Id: agentId,
                  Date: db_date,
              });
          
              if (check_duplicate_entry.length > 0) {
                  console.log("Duplicate entry found for", db_date);
          
                  // Count how many records exist for this agent
                  const totalEntries = await agentData.countDocuments({ agent_Id: agentId });
          
                  let prev_date = new Date(year, month - 1, day - 1);
                  let prev_db_date;
                  let iteration_count = totalEntries; // Set max iterations to total entries for this agent
          
                  while (iteration_count-- > 0) {
                      let prev_day = prev_date.getDate().toString().padStart(2, "0");
                      let prev_month = (prev_date.getMonth() + 1).toString().padStart(2, "0");
                      let prev_year = prev_date.getFullYear();
                      prev_db_date = `${prev_day}-${prev_month}-${prev_year}`;
          
                      const existingEntry = await agentData.findOne({
                          agent_Id: agentId,
                          Date: prev_db_date,
                      });
          
                      if (!existingEntry) break; // Stop when we find an available date
          
                      // Move to the previous date again
                      prev_date.setDate(prev_date.getDate() - 1);
                  }
          
                  console.log("Updating existing entry to", prev_db_date);
                  
                  await agentData.updateOne(
                      { _id: check_duplicate_entry[0]._id }, // Fix: Update old entry only
                      { $set: { Date: prev_db_date } }
                  );
          
                  const agentdata = {
                    agent_Id: agentId,
                    Date: db_date, // Ensure this stays as today's date
                    Daily_wages: Daily_wages,
                    name: agent_name,
                };
            
                const response = await agentData.create(agentdata);
                console.log(response);
            
                if (response) {
                    return res.status(200).json({ message: "Data inserted successfully" });
                } else {
                    return res.status(400).json({ message: "Failed to insert data" });
                } 
              } else {
                  // Insert new agent data only if there is NO duplicate entry
                  const agentdata = {
                      agent_Id: agentId,
                      Date: db_date,
                      Daily_wages: Daily_wages,
                      name: agent_name
                  };
                
                  const response = await agentData.create(agentdata);
                  console.log(response);
                
                  if (response) {
                      return res.status(200).json({ message: "Data inserted successfully" });
                  } else {
                      return res.status(400).json({ message: "Failed to insert data" });
                  }
                }
          
              // Insert new agent data (always with today's date)
              
          }       
        }
    } catch (error) {
        console.log(error);
        return res.status(500).json({ message: "Internal server error" });
    }
}

export const calculatewages=async(req,res)=>{
    try{
       const {agentId}=req.params;
       console.log("the agent id is",agentId);
       const agent_data = await Users.find({ _id: agentId ,usertype:"agent"});
       if(!agent_data){
        return res.status(404).json({message:"Agent not found"});
       }
       //calculate the settled amount
       const total_settled_amount=await agentData.find({agent_Id:agentId,settlement_status:true,Daily_wages:{$gt:0}})
       const totalsettled_amount = total_settled_amount.reduce((total, record) => total + record.Daily_wages, 0);
       console.log("the settled amount is",totalsettled_amount);
       const totalunsettled_amount=await agentData.find({agent_Id:agentId,settlement_status:false,Daily_wages:{$gt:0}});
        console.log("the not settled amount is",totalunsettled_amount);
       const totalunsettled_wages = totalunsettled_amount.reduce((total, record) => total + record.Daily_wages, 0);
       console.log("the unsettled amount is",totalunsettled_wages);
       
      
       //fetch the agent details and check the advance there
       const agent_details = await Users.findOne({ _id: agentId });
       const advance=agent_details.Advance;
       console.log("the advance is",advance);
       const pending_amount=totalunsettled_wages-advance;
       console.log("the pending amount is",pending_amount);
    //    if(!totalsettled_amount||!totalunsettled_wages||!pending_amount){
    //     res.status(200).json({
    //         message: "No data found",
    //         totalsettled_amount:0,
    //         // totalunsettled_wages:0,
    //         pending_amount:0,
    //         advance:0
    //     })
    //    }
    //    else{
        res.status(200).json({
            message: "Data found",
            totalsettled_amount:totalsettled_amount,
            // totalunsettled_wages:totalunsettled_wages,
            pending_amount:totalunsettled_wages,
            advance:advance
        })
    //    }


    }catch(error){
        console.log(error);
        return res.status(500).json({ message: "Internal server error" });
    }
}
export const getDailyPaymentHistory = async (req, res) => {
  try {
      const { agentId } = req.params;
      const { month, date } = req.query; // Get month and date from query params
      console.log("the month is",month);
      console.log("the date is",date);

      let filter = { agent_Id: agentId, Daily_wages: { $gt: 0 }, settlement_status: false };

      if (month) {
          // Ensure month filter is properly formatted (01, 02, ..., 12)
          const monthPattern = new RegExp(`-${month}-`); // Matches "-MM-" in the date
          filter.Date = { $regex: monthPattern };
      }

      if (date) {
          // Ensure full date format matches exactly (dd-mm-yyyy)
          filter.Date = date; // Match exact date if provided
      }

      const agent_data = await agentData.find(filter);

      if (!agent_data || agent_data.length === 0) {
          return res.status(200).json({ message: 'History not found' });
      }

      console.log("The agent data is", agent_data);

      const filteredData = agent_data.map(record => ({
          _id: record._id,
          Date: record.Date,
          Daily_wages: record.Daily_wages
      }));

      res.status(200).json({
          message: "Data found",
          data: filteredData
      });

  } catch (error) {
      console.log(error);
      return res.status(500).json({ message: "Internal server error" });
  }
};


//api for fetch the amount which is not settled to show in the admin side
export const getAllPaymentData=async(req,res)=>{
    try{ const limit = parseInt(req.query.limit) || 10; 
         const page = parseInt(req.query.offset) || 1; 
         console.log("the limit and the offset is",limit,page);
         const {agentId}=req.params;
         const skip = (page - 1) * limit;
         console.log("the agent id is",agentId);
         const unsettled_data=await agentData.find({agent_Id:new mongoose.Types.ObjectId(agentId)}) .sort({ createdAt: -1 }) 
         .skip(skip)
         .limit(limit);
         
         const totalData=unsettled_data.length;
         
         if(!unsettled_data){
            return res.status(200).json({message:'No unsettled data found',data:[]});
         }
         else{
            return res.status(200).json({message:'Unsettled data found',data:unsettled_data,total_data:totalData})
         }
    }catch(error){
        console.log(error);
        return res.status(500).json({message:"Internal server error"});
    }
}
export const addAdvance=async(req,res)=>{
    try{
       const {agentId}=req.params;
       let { advance } = req.body;
      //  advance=advance*100;
        const roundedAdvance = parseInt(advance, 10)*100; // Convert to integer (base 10)
        const timestamp = Date.now();


       console.log("the advance data is",advance);
       const {mode_of_advance}=req.body;
       
       let fa;
       console.log("the mode of advance given is",mode_of_advance);
    
       

       var today_Date = new Date().toISOString().slice(0, 10); 
                var [year, month, day] = today_Date.split("-");
                let db_date = `${day}-${month}-${year}`;

                db_date=db_date.toString();
       
       
       
       if(mode_of_advance=="Cash"){
        const user = await Users.findOne({ _id: new mongoose.Types.ObjectId(agentId) });
        if (user) {
         const previousAdvance = parseInt(user.Advance) || 0;
         const newAdvance = previousAdvance + (parseInt(advance) || 0);
   
       
         // Update the Advance field with the new value
         const update_advance_inuser = await Users.updateOne(
           { _id: new mongoose.Types.ObjectId(agentId) },
           { $set: { Advance: newAdvance } }
         );

         //update the agentdata table also
         const advance_inagentdata=({
          advance:advance,
          Date:db_date,
          agent_Id:agentId,
          advance_mode:mode_of_advance,
          paymentdetails:[{
            payment_date:timestamp,
            amount:advance
          }]
  
         })
         const add_advance_totable=await agentData.create(advance_inagentdata);
         if(add_advance_totable){
          return res.status(200).json({message:"Advance added successfully",data:add_advance_totable});
         }
         else{
          return res.status(400).json({message:"Failed to add advance"});
         }
       
       }
      } else {
        console.log("User not found");
      }
      if(mode_of_advance=="UPI"||mode_of_advance=="IMPS"){
      const payment_details=await Paymentdetails.find({agent_Id:agentId,mode:mode_of_advance,default:1});
       console.log("the payment details is",payment_details);
        fa=  payment_details[0].fa;
      }
      const auth = {
        username: apiKey,
        password: apiSecret,
    };
      
    const requestData = {
        account_number: process.env.ACC_NO,
        // account_number: "4564566996247139",
        fund_account_id: fa,
        
        amount:roundedAdvance,
        currency: "INR",
        mode: mode_of_advance,
        purpose: "payout",
        notes: { notes: `payment from RecyclePay for Advance` },
        // purpose: ``,
    }
    try{
    const response = await axios.post(`https://api.razorpay.com/v1/payouts`, requestData, {
        headers: {
            'Content-Type': 'application/json',
            // 'X-Payout-Idempotency': idempotencyKey,
        },
        auth: auth,
    })
    console.log("the response is",response);
    if(response.status==200){
        
        
        if(mode_of_advance=="UPI"){
          const user = await Users.findOne({ _id: new mongoose.Types.ObjectId(agentId) });
          if (user) {
           const previousAdvance = parseInt(user.Advance) || 0;
           const newAdvance = previousAdvance + (parseInt(advance) || 0);
     
         
           // Update the Advance field with the new value
           const update_advance_inuser = await Users.updateOne(
             { _id: new mongoose.Types.ObjectId(agentId) },
             { $set: { Advance: newAdvance } }
           );
  
           //update the agentdata table also
           const advance_inagentdata=({
            advance:advance,
            Date:db_date,
            agent_Id:agentId,
            advance_mode:mode_of_advance,
            paymentdetails:[{
              payment_date:response.data.created_at,
              p_outId:response.data.id,
              amount:response.data.amount/100
            }]

    
           })
           const add_advance_totable=await agentData.create(advance_inagentdata);
           if(add_advance_totable){
            return res.status(200).json({message:"Advance added successfully",data:add_advance_totable});
           }
           else{
            return res.status(400).json({message:"Failed to add advance"});
           }
         
         }
            }
            if(mode_of_advance=="IMPS"){
              const user = await Users.findOne({ _id: new mongoose.Types.ObjectId(agentId) });
              if (user) {
               const previousAdvance = parseInt(user.Advance) || 0;
               const newAdvance = previousAdvance + (parseInt(advance) || 0);
         
             
               // Update the Advance field with the new value
               const update_advance_inuser = await Users.updateOne(
                 { _id: new mongoose.Types.ObjectId(agentId) },
                 { $set: { Advance: newAdvance } }
               );
      
               //update the agentdata table also
               const advance_inagentdata=({
                advance:advance,
                Date:db_date,
                agent_Id:agentId,
                advance_mode:mode_of_advance,
                paymentdetails:[{
                  payment_date:response.data.created_at,
                  p_outId:response.data.id,
                  amount:response.data.amount/100
                }]
        
               })
               const add_advance_totable=await agentData.create(advance_inagentdata);
               if(add_advance_totable){
                return res.status(200).json({message:"Advance added successfully",data:add_advance_totable});
               }
               else{
                return res.status(400).json({message:"Failed to add advance"});
               }
             
             }
                }
          
          
          
          // const update_user_table=await Users.findOneAndUpdate({_id:agentId},{$set:{Advance:0}})
          // console.log("the updated advance is",update_user_table);
          return res.status(200).json({message:"Payment successful"});
    }
  
    else{
        console.log("the payment is failed");
        return res.status(400).json({message:"Payment failed"});
    }
  
}catch(error){
    console.log("the error is",error);
}

       
    }catch(error){
        console.log(error);
        return res.status(500).json({message:"Internal server error"})
    }
}
//api for get the advance history
export const getAdvanceHistory=async(req,res)=>{
    try{
        const{agentId}=req.params;
        const {month,date}=req.query;
        console.log("the month is",month);
        console.log("the date is",date);

        const filter={agent_Id:agentId,advance: { $gt: 0 } }
        
        if (month) {
          const monthPattern = new RegExp(`-${month}-`); 
          filter.Date = { $regex: monthPattern };
      }

      if (date) {
          // Ensure full date format matches exactly (dd-mm-yyyy)
          filter.Date = date; // Match exact date if provided
      }
      const advancehistory=await agentData.find(filter).sort({createdAt:-1});


        if(!advancehistory){
            return res.status(200).json({message:"No advance history found",data:[]})
        }
        else{
            return res.status(200).json({message:"Advance history found",data:advancehistory})
        }
    }catch(error){
        console.log(error);
        return res.status(500).json({message:'Internal server error'});
    }
}
//api to fetch the last settled amount
export const getLastSettlement = async (req, res) => {
  try {
    const { agentId } = req.params;
    const{month,date}=req.query
    console.log("month",month);
    console.log("date",date);
    let matchStage = {
      agent_Id: new mongoose.Types.ObjectId(agentId),
      settlement_status: true, // Filtering only settled payments
    };
    if(month){
      matchStage["$expr"] = {
        $eq: [{ $month: { $toDate: "$settlement_date" } }, parseInt(month)],
      };
    }
    if(date){
      matchStage["$expr"] = {
        ...matchStage["$expr"],
        $eq: [{ $dayOfMonth: { $toDate: "$settlement_date" } }, parseInt(date)],
      };
    }
    const settlements = await agentData.aggregate([
      { $match: matchStage },
      {
        $unwind: "$paymentdetails"
      },
      // Unwind paymentdetails array
      {
        $sort: {
          "paymentdetails.payment_date": 1
        }
      },
      // Sort by payment date
      {
        $group: {
          _id: "$paymentdetails.payment_date",
          // Group by payment date
          name: {
            $first: "$name"
          },
          // Take the first name (assuming same for all grouped records)
          settlement_date: {
            $first: "$settlement_date"
          },
          p_outId: {
            $first: "$paymentdetails.p_outId"
          },
          amount: {
            $first: "$paymentdetails.amount"
          }
        }
      },
      {
        $sort: {
          _id: -1
        }
      }
      // Sort by payment date in ascending order
    ]);
    if(!month){
      return res.status(200).json({data:settlements});
    }
    if(!date){
      return res.status(200).json({data:settlements});
    }

    return res.status(200).json({data:settlements});

    // Find all settlements for the given agent where settlement_status is true
    

  } catch (error) {
    console.error(error);
    return res.status(500).json({ message: "Internal server error" });
  }
};


  //generate the ci and fa for the customer
  export const generateCIandFA = async(req,res)=>{
    try{
          const{agentId}=req.params;
          const {account_type,paymentdetails}=req.body;
        //   console.log("the mode of payment is",mode_of_payment);
          console.log("the payment details are",paymentdetails);
          console.log("the bank details account number is",paymentdetails.account_number);
          console.log("the ifsc code is",paymentdetails.IFSC_code);
          console.log("the account holder name is",paymentdetails.name);
        let requestData={};
        let payment = {};
          const auth = {
            username: apiKey,
            password: apiSecret,
        };
        const user_data=await Users.findById({_id:agentId});
        if(!user_data){
            return res.status(404).json({message:"User not found"});
        }
        console.log("the user data is",user_data);
        const name=user_data.name;
        const email=user_data.email;
        const mobile=user_data.mobile;
        if(!user_data.ci){
            if (!name || name.trim().length < 3) {
                return res.status(400).json({
                    isSuccess: false,
                    message: "Customer name must be at least 3 characters long and should not have trailing spaces.",
                });
            }
            const emailRegex = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
            if (!email || !emailRegex.test(email)) {
                return res.status(400).json({
                    isSuccess: false,
                    message: "Invalid email address found for the customer.",
                });
            }
            const mobileRegex = /^[0-9]{10}$/;
            if (!mobile || !mobileRegex.test(mobile)) {
                return res.status(400).json({
                    isSuccess: false,
                    message: "Invalid mobile number found for the customer. It must be 10 digits.",
                });
            }
            //generate the ci here
            const requestDataForCi = {
                name: name.trim(),
                email: email.trim(),
                contact: mobile,
            }; 
            try{
                 const ciResponse = await axios.post(`https://api.razorpay.com/v1/contacts`, requestDataForCi, {
                    headers: {
                        'Content-Type': 'application/json',
                    },
                    auth: auth,
                });
                console.log('CI Generation Response is:', ciResponse.data);
                //set the ci after generation
                const update_user_data=await Users.findOneAndUpdate({_id:agentId},{ $set: { ci: ciResponse.data.id } })
                console.log("the update field after generating the ci is",update_user_data);

            } catch(error){
                console.log(error);
                return res.status(500).json({message:"Internal server Error in generating CI"});
            }
        }
        
            // return res.status(200).json({message:"ci found for the user",data:user_data.ci})
            const ci_in_user=user_data.ci;
            if(paymentdetails && account_type=='bank_account'){
                  requestData = {
                    contact_id: ci_in_user,
                    account_type: account_type,
                    bank_account: paymentdetails,
                };
                console.log("the requested data for the bank account detailks is",requestData);
            }
            else if (paymentdetails && account_type === "vpa") {
                console.log("the upi id is",paymentdetails.vpa);
                const existingPayment = await AgentPaymentdetails.findOne({ agent_Id:agentId, vpa:paymentdetails.vpa });
    
                if (existingPayment) {
                    return res.json({
                        isSuccess: true,
                        msg: "UPI already exists.",
                    });
                }
    
                requestData = {
                    contact_id: ci_in_user,
                    account_type: account_type,
                    vpa: paymentdetails.vpa,
                };
                console.log("the requested data is",requestData);

            }
            if (Object.keys(requestData).length !== 0) {
                const response = await axios.post(`https://api.razorpay.com/v1/fund_accounts`, requestData, {
                    headers: {
                        'Content-Type': 'application/json',
                    },
                    auth: auth,
                });
    
                if (response) {
                    if (paymentdetails && account_type=='bank_account') {
                        payment = await AgentPaymentdetails.create({
                            agent_Id: new mongoose.Types.ObjectId(agentId),
                            ci: ci_in_user,
                            fa: response.data.id,
                            account_type: account_type,
                            bank_account: paymentdetails,
                            mode: "IMPS",
                            default: 1,
                        });
                    } else if (paymentdetails && account_type === "vpa") {
                        const countPayment = await AgentPaymentdetails.countDocuments({ agent_Id: agentId, mode: "UPI" });
                        console.log("countPayment", countPayment);
                        if (countPayment == 0) {
                            payment = await AgentPaymentdetails.create({
                                agent_Id: new mongoose.Types.ObjectId(agentId),
                                ci: ci_in_user,
                                fa: response.data.id,
                                account_type: account_type,
                                vpa: paymentdetails.vpa,
                                mode: "UPI",
                                default: 1,
                            });
                        } else {
                           
                                payment = await AgentPaymentdetails.create({
                                    agent_Id: new mongoose.Types.ObjectId(agentId),
                                    ci: ci_in_user,
                                    fa: response.data.id,
                                    account_type: account_type,
                                    vpa: paymentdetails.vpa,
                                    mode: "UPI",
                                    default: 0,
                            });
                        }
                        
                    }
    
                    if (payment) {
                        return res.json({
                            isSuccess: true,
                            message: `Payment ${account_type} details added.`,
                            fa: payment.fa,
                        });
                    } else {
                        return res.json({
                            isSuccess: false,
                            message: "Failed to add payment details.",
                        });
                    }
                }
            } else {
                return res.json({
                    isSuccess: false,
                    message: "No valid data provided.",
                });
            }


        
    }catch(error){
        console.log(error);
        return res.status(500).json({message:'Internal server error'});
    }
  }
  //api to fetch the account details and the payment details of the agent by Id
  export const getAccountDetailsOfAgent = async (req, res) => {
    try {
        const { agentId } = req.params;

        // Fetch all payment details for the agent with 'default: 1'
        const agent_account_details = await AgentPaymentdetails.find({ agent_Id: agentId, default: 1 });

        if (!agent_account_details.length) {
            return res.status(400).json({ message: "Account details not found for the agent" });
        }

        // Separate Bank and UPI details
        const bankDetails = agent_account_details.find(item => item.account_type === "bank_account") || null;
        const upiDetails = agent_account_details.find(item => item.account_type === "vpa") || null;

        return res.status(200).json({
            isSuccess: true,
            data: {
                bank: bankDetails ? bankDetails.bank_account : null,
                upi: upiDetails ? upiDetails.vpa : null
            }
        });

    } catch (error) {
        console.log(error);
        return res.status(500).json({ message: 'Internal server error' });
    }
};
//api for otp generation store in the database and send to the admin also
 export const sendotpToAdmin=async(req,res)=>{
    try{
          const {agentId}=req.params;
          const otp = Math.floor(1000 + Math.random() * 9000);
            console.log("the otp is",otp);
             await sendEmailToAdmin(otp);
            const otp_data={
                otp:otp,
                email:'neelima@ajatus.co.in'
            }
            const otp_details = await agentpaymentotp.findOneAndUpdate(
                { email: "neelima@ajatus.co.in" },        // Filter to match the document by email
                { $set: { otp: otp } }    // Update the otp field
                      // Options: return the updated document and do not insert a new document
              );
              if (!otp_details) {
                const create_otp=await agentpaymentotp.create(otp_data);
                if(create_otp){
                    return res.status(200).json({message:"otp sent to admin",isSuccess:true});
                }
              }
              
            console.log("the otp details is",otp_details);
            if(otp_details){
                return res.status(200).json({message:'OTP sent to the admin successfully',isSuccess:true})
            }
            else{
                return res.status(400).json({message:'Failed to send OTP to the admin',isSuccess:false})
            }


    }catch(error){
        console.log(error);
        return res.status(500).json({message:"Internal server error"});
    }
 }

 //function for send the otp
 async function sendEmailToAdmin(otp) {
     var defaultClient = SibApiV3Sdk.ApiClient.instance;
     // Configure API key authorization: api-key
     var apiKey = defaultClient.authentications['api-key'];
     console.log("the api key is", apiKey)
     apiKey.apiKey = process.env.MAILAPIKEY;
     // console.log("the api key after this is", apiKey)
     // Uncomment below two lines to configure authorization using: partner-key
     // var partnerKey = defaultClient.authentications['partner-key'];
     // partnerKey.apiKey = 'YOUR API KEY';
     var apiInstance = new SibApiV3Sdk.TransactionalEmailsApi();
     var adminMail = new SibApiV3Sdk.SendSmtpEmail();
     const getIndianTime = () => {
         return new Date().toLocaleTimeString('en-IN', { 
             timeZone: 'Asia/Kolkata', 
             hour: '2-digit', 
             minute: '2-digit', 
             second: '2-digit', 
             hour12: false 
         });
     };
 
     try {
 
         adminMail = {
             to: [
                 
                    // { email: 'gyanaranjan@ajatus.co.in'},
                    { email: 'neelima@ajatus.co.in'},
                    // { email: 'omprakash.sadangi@ajatus.co.in'},
                     
                 
             ],
             from: {
                 email: 'support@ceibagreen.com'
             },
             templateId:40 ,
             params: {
                 otp:otp
             },
             subject: `Your payment verification otp is ${otp}`,
             headers: {
                 'X-Mailin-custom': 'custom_header_1:custom_value_1|custom_header_2:custom_value_2'
             },
         }
         const data = await apiInstance.sendTransacEmail(adminMail);
         console.log("mail send  for verify by admin successfully", data.messageId);
         
     } catch (error) {
         console.log(error);
     }
 }
 //api for otp verification the otp which will be the admin enter
 export const verifyAdminOtp=async(req,res)=>{
    const {otp}=req.body;
    const verify_otp=await agentpaymentotp.find({otp:otp});
    if(verify_otp.length>0){
        return res.status(200).json({message:"otp verification successful"});
    }
    else{
        return res.status(400).json({message:"invalid otp"});
    }
 }
 //api for whole payment settlement for admin
 export const settleAllPayment=async(req,res)=>{
    try{
        const{agentId}=req.params;
        const {mode}=req.body;
        
        
        

        var today_Date = new Date().toISOString().slice(0, 10); 
                var [year, month, day] = today_Date.split("-");
                var db_date = `${day}-${month}-${year}`;
                const date_toString=db_date.toString();

        if(mode=="Cash"){
            const update_agent_data = await agentData.updateMany(
                { agent_Id: agentId },
                [
                  {
                    $set: {
                      settlement_status: true,
                      settlement_mode:"Cash",
                      settlement_date: {
                        $cond: {
                          if: { $gt: ["$settlement_date", null] }, // Check if settlement_date exists
                          then: "$settlement_date", // Keep existing value
                          else: date_toString // Set new value if null
                        }
                      },
                    //   paymentdetails: [
                    //     {
                    //       payment_date: response.data.created_at,
                    //       p_outId: response.data.id,
                    //       amount: response.data.amount
                    //     }
                    //   ]
                    }
                  }
                ]
              );
              return res.status(200).json({message:"payment settled successfully"});
        }
        
        console.log("the mode is",mode);
        const totalunsettled_amount=await agentData.find({agent_Id:agentId,settlement_status:false,Daily_wages:{$gt:0}});
        console.log("the not settled amount is",totalunsettled_amount);
       const totalunsettled_wages = totalunsettled_amount.reduce((total, record) => total + record.Daily_wages, 0);
       console.log("the unsettled amount is",totalunsettled_wages);

       const advance_ofAgent=await Users.findById({_id:agentId});
       console.log("the advance data os the agent is",advance_ofAgent);
       const advance=advance_ofAgent.Advance;
       console.log("the advance of agent is",advance);

       const total = Math.round(parseFloat(totalunsettled_wages) - parseFloat(advance));
       console.log("the total is",total ,"the type of the total is",typeof total);

       //now fetch the account details and the upi according to the mode which is coming
       const account_details=await Paymentdetails.find({agent_Id:agentId,mode:mode,default:1});
       console.log("the account details is",account_details);
       if(!account_details){
        return res.status(400).json({message:"account details not found"});
       }
       const payment_fa=account_details[0].fa;
       console.log("the payment fa is",payment_fa);

       const auth = {
        username: apiKey,
        password: apiSecret,
    };
      
    const requestData = {
        account_number: process.env.ACC_NO,
        // account_number: "4564566996247139",
        fund_account_id: payment_fa,
        // amount: req.body.est_price * 100,
        // amount: Math.round(req.body.est_price) * 100,
        // amount: parseInt((OrderID.est_price).toFixed(2) * 100),
        // amount: parseInt(parseFloat(OrderID.est_price).toFixed(2) * 100),
        amount:total*100,
        currency: "INR",
        mode: mode,
        purpose: "payout",
        notes: { notes: `payment from RecyclePay` },
        // purpose: ``,
    }
    try{
    const response = await axios.post(`https://api.razorpay.com/v1/payouts`, requestData, {
        headers: {
            'Content-Type': 'application/json',
            // 'X-Payout-Idempotency': idempotencyKey,
        },
        auth: auth,
    })
    console.log("the response is",response);
    if(response.status==200){
        console.log("the payment is successful");
        // const update_agent_data = await agentData.updateMany(
        //     { agent_Id: agentId },
        //     [
        //       {
        //         $set: {
        //           settlement_status: true,
        //           settlement_date: {
        //             $cond: {
        //               if: { $gt: ["$settlement_date", null] }, // Check if settlement_date exists
        //               then: "$settlement_date", // Keep existing value
        //               else: date_toString // Set new value if null
        //             }
        //           },
        //           paymentdetails: [
        //             {
        //               payment_date: response.data.created_at,
        //               p_outId: response.data.id,
        //               amount: response.data.amount
        //             }
        //           ]
        //         }
        //       }
        //     ]
        //   );
        if(mode=="UPI"){
            const update_agent_data = await agentData.updateMany(
                // { _id: { $in: paymentIds } },
                { agent_Id: agentId },
                [
                  {
                    $set: {
                      settlement_status: true,
                      settlement_mode:'UPI',
                      settlement_date: {
                        $cond: {
                          if: { $gt: ["$settlement_date", null] }, 
                          then: "$settlement_date",
                          else: date_toString 
                        }
                      },
                      paymentdetails: [
                        {
                          payment_date: response.data.created_at,
                          p_outId: response.data.id,
                          amount: response.data.amount/100
                        }
                      ]
                    }
                  }
                ]
              );
            }
            if(mode=="IMPS"){
                const update_agent_data = await agentData.updateMany(
                    // { _id: { $in: paymentIds } },
                    { agent_Id: agentId },
                    [
                      {
                        $set: {
                          settlement_status: true,
                          settlement_mode:'IMPS',
                          settlement_date: {
                            $cond: {
                              if: { $gt: ["$settlement_date", null] }, 
                              then: "$settlement_date",
                              else: date_toString 
                            }
                          },
                          paymentdetails: [
                            {
                              payment_date: response.data.created_at,
                              p_outId: response.data.id,
                              amount: response.data.amount/100
                            }
                          ]
                        }
                      }
                    ]
                  );
                }
          
          
          
          const update_user_table=await Users.findOneAndUpdate({_id:agentId},{$set:{Advance:0}})
          console.log("the updated advance is",update_user_table);
          return res.status(200).json({message:"Payment successful"});
    }
    else{
        console.log("the payment is failed");
        return res.status(400).json({message:"Payment failed"});
    }
}catch(error){
    console.log("the error is",error);
}
    


    }catch(error){
        console.log(error);
        return res.status(500).json({message:"Internal server error for agent settlement"});
    }
 }


 //api for single payment settlement for the agent
 export const singlePaymentSettlement = async (req, res) => {
  try {
      console.log("====== Start of singlePaymentSettlement API ======");

      const { agentId } = req.params;
      console.log("Agent ID:", agentId);

      const { mode, paymentIds, selectedOption } = req.body;
      console.log("Received Mode:", mode);
      console.log("Received Payment IDs:", paymentIds);
      console.log("Selected Option:", selectedOption);

      console.log("Advance Payment Condition Met");
          const istTimestamp = new Date().toLocaleString("en-US", { timeZone: "Asia/Kolkata" });
          console.log("the indian time stramp is",istTimestamp);
          const timestamp = Math.floor(Date.now() / 1000);

          console.log("the time stramp is",timestamp);
          
        

      let totalDailyWages;
      let today_Date = new Date().toISOString().slice(0, 10);
      let [year, month, day] = today_Date.split("-");
      let db_date = `${day}-${month}-${year}`;
      const date_toString = db_date.toString();

      const get_account_type = await Paymentdetails.find({ agent_Id: agentId, mode: mode, default: 1 });

      if (!get_account_type) {
          console.log("Account Details Not Found");
          return res.status(400).json({ message: "Account Details not found" });
      }
      console.log("Payment Details:", get_account_type);

      const fa = get_account_type[0].fa;
      console.log("FA ID:", fa);

      // Settlement mode is Cash
      if (mode == "Cash") {
          console.log("Processing Cash Settlement...");
          const update_agent_data = await agentData.updateMany(
              { agent_Id: agentId },
              [{
                  $set: {
                      settlement_status: true,
                      settlement_mode: "Cash",
                      settlement_date: {
                          $cond: {
                              if: { $gt: ["$settlement_date", null] },
                              then: "$settlement_date",
                              else: date_toString
                          }
                      }
                  }
              }]
          );
          console.log("Cash Settlement Updated:", update_agent_data);
      }

      console.log("Fetching Payment Data...");
      const get_payment_data = await agentData.find({
          agent_Id: agentId,
          settlement_status: false,
          _id: { $in: paymentIds }
      });

      console.log("Fetched Payment Data:", get_payment_data);

      totalDailyWages = get_payment_data.reduce((acc, curr) => acc + parseInt(curr.Daily_wages, 10), 0);
      console.log("Total Daily Wages:", totalDailyWages);

      console.log("Fetching Advance Amount...");
      const get_advance = await Users.findById({ _id: agentId });
      const advance_amount = get_advance.Advance;
      console.log("Advance Amount:", advance_amount);

      if (selectedOption && selectedOption.advance === true && advance_amount > 0) {
          


           

          if (totalDailyWages > advance_amount) {
              console.log("Deducting Advance: Remaining Amount after Deduction");
               const totalAmount = totalDailyWages - advance_amount;
              const auth = {
                username: apiKey,
                password: apiSecret,
            };
            const requestData = {
                account_number: process.env.ACC_NO,
                fund_account_id: fa,
                amount: totalAmount * 100,
                currency: "INR",
                mode: mode,
                purpose: "payout",
                notes: { notes: `Payment from RecyclePay` }
            };
            
            const response = await axios.post(`https://api.razorpay.com/v1/payouts`, requestData, {
              headers: { 'Content-Type': 'application/json' },
              auth: auth,
            });
            if(response.status == 200){

              console.log("Updating User Advance to 0...");
              await Users.findOneAndUpdate({ _id: agentId }, { $set: { Advance: 0 } });


              console.log("Updating Agent Data after Advance Deduction...");
              await agentData.updateMany(
                  { _id: { $in: paymentIds } },
                  [{
                      $set: {
                          settlement_status: true,
                          settlement_mode: "Advance",
                          settlement_date: {
                              $cond: {
                                  if: { $gt: ["$settlement_date", null] },
                                  then: "$settlement_date",
                                  else: date_toString
                              }
                          },
                          paymentdetails: [
                            { 
                            payment_date: response.data.created_at ,
                            p_outId:response.data.id,
                            amount:response.data.amount / 100
                          }

                          ]
                      }
                  }]
              );

              console.log("Data Updated Successfully after Advance Deduction");
              return res.status(200).json({ message: "Data updated successfully" });
          }
        }

          if (advance_amount > totalDailyWages) {
              console.log("Advance is greater than Total Wages, updating remaining advance amount...");
              const updatedAdvance = advance_amount - totalDailyWages;
              await Users.findOneAndUpdate({ _id: agentId }, { $set: { Advance: updatedAdvance } });

              console.log("Updating Agent Data after Advance Deduction...");
              await agentData.updateMany(
                  { _id: { $in: paymentIds } },
                  [{
                      $set: {
                          settlement_status: true,
                          settlement_mode: "Advance",
                          settlement_date: {
                              $cond: {
                                  if: { $gt: ["$settlement_date", null] },
                                  then: "$settlement_date",
                                  else: date_toString
                              }
                          },
                          paymentdetails: [{ payment_date: timestamp },{amount:totalDailyWages}]
                      }
                  }]
              );

              console.log("Data Updated Successfully with Remaining Advance");
              return res.status(200).json({ message: "Data updated successfully" });
          }

          if (advance_amount === totalDailyWages) {
            console.log("Advance Amount exactly equals Total Wages");
        
            // Reset the Advance amount for the user
            await Users.findByIdAndUpdate({ _id: agentId }, { $set: { Advance: 0 } });
        
            console.log("Updating Agent Data for Exact Advance Match...");
            await agentData.updateMany(
                { _id: { $in: paymentIds } },
                [{
                    $set: {
                        settlement_status: true,
                        settlement_mode: "Advance",
                        settlement_date: {
                            $cond: {
                                if: { $gt: ["$settlement_date", null] },
                                then: "$settlement_date",
                                else: date_toString
                            }
                        },
                        paymentdetails: [{ payment_date: timestamp, amount: totalDailyWages }]
                    }
                }]
            );
        
            console.log("Data Updated Successfully for Exact Match");
            return res.status(200).json({ message: "Data updated successfully" });  // Return here to stop execution
        }
      }

      console.log("Fetching Account Type Details...");
      // const get_account_type = await Paymentdetails.find({ agent_Id: agentId, mode: mode, default: 1 });

      // if (!get_account_type) {
      //     console.log("Account Details Not Found");
      //     return res.status(400).json({ message: "Account Details not found" });
      // }
      // console.log("Payment Details:", get_account_type);

      // const fa = get_account_type[0].fa;
      // console.log("FA ID:", fa);

      const auth = {
          username: apiKey,
          password: apiSecret,
      };
      const requestData = {
          account_number: process.env.ACC_NO,
          fund_account_id: fa,
          amount: totalDailyWages * 100,
          currency: "INR",
          mode: mode,
          purpose: "payout",
          notes: { notes: `Payment from RecyclePay` }
      };

      console.log("Initiating Razorpay API Request...");
      try {
          const response = await axios.post(`https://api.razorpay.com/v1/payouts`, requestData, {
              headers: { 'Content-Type': 'application/json' },
              auth: auth,
          });

          if (response.status == 200) {
              console.log("Payment Successful via Razorpay");

              console.log(`Updating Agent Data for ${mode} Mode Settlement...`);
              await agentData.updateMany(
                  { _id: { $in: paymentIds } },
                  [{
                      $set: {
                          settlement_status: true,
                          settlement_mode: mode,
                          settlement_date: {
                              $cond: {
                                  if: { $gt: ["$settlement_date", null] },
                                  then: "$settlement_date",
                                  else: date_toString
                              }
                          },
                          paymentdetails: [{
                              payment_date: response.data.created_at,
                              p_outId: response.data.id,
                              amount: response.data.amount / 100
                          }]
                      }
                  }]
              );

              console.log("Payment and Data Update Successful");
              return res.status(200).json({ message: "Payment successful and data updated" });
          } else {
              console.log("Payment Failed",e);
              return res.status(500).json({ message: "Payment failed" });
          }
      } catch (error) {
          console.log("Error in Razorpay API Request:", error);
          return res.status(500).json({ message: "Internal server error in Razorpay" });
      }

  } catch (error) {
      console.log("Internal Server Error:", error);
      return res.status(500).json({ message: "Internal server error" });
  }
};


 //api for filter the data for settlement date wise
 export const filterSettledDate = async (req, res) => {
  try {
    const { fullDate } = req.params; 

    
    if (!fullDate || !/^\d{2}-\d{2}-\d{4}$/.test(fullDate)) {
      return res.status(400).json({ message: "Invalid date format. Use dd-mm-yyyy." });
    }

    
    const regex = new RegExp(`^${fullDate}$`, "i");

    
    const settlement_data = await agentData.find({
      Daily_wages: { $gt: 0 }, 
      settlement_status:true,
      settlement_date: { $regex: regex } 
  });
  

    console.log("The data is:", settlement_data);

    return res.status(200).json({ success: true, data: settlement_data });
  } catch (error) {
    console.error(error);
    return res.status(500).json({ message: "Internal server error" });
  }
};

//api for filter the data for pending data
export const PendingDatefilter = async (req, res) => {
  try {
    const { fullDate } = req.query; 
    const {agentId} =req.query;
    console.log("the agent id and the fulldate is",agentId,fullDate);
    

    if (!fullDate || !/^\d{2}-\d{2}-\d{4}$/.test(fullDate)) {
      return res.status(400).json({ message: "Invalid date format. Use dd-mm-yyyy." });
    }
    const regex = new RegExp(`^${fullDate}$`, "i");

    const pending_data = await agentData.find({agent_Id:agentId,settlement_status:false,
      Date: { $regex: regex }
    });

    console.log("The data is:", pending_data);

    return res.status(200).json({ success: true, data: pending_data });
  } catch (error) {
    console.error(error);
    return res.status(500).json({ message: "Internal server error" });
  }
};

//api for filter the data for advance amount
export const AdvanceAmountfilter = async (req, res) => {
  try{
      const {fullDate}=req.query;
      const {agentId} =req.query;
      if (!fullDate || !/^\d{2}-\d{2}-\d{4}$/.test(fullDate)) {
        return res.status(400).json({ message: "Invalid date format. Use dd-mm-yyyy." });
      }
      const regex = new RegExp(`^${fullDate}$`, "i");
  
      const pending_data = await agentData.find({agent_Id:agentId,advance:{$gt:0},
        Date: { $regex: regex }
      });
  
      console.log("The data is:", pending_data);
  
      return res.status(200).json({ success: true, data: pending_data });

  }catch(error){
    console.error(error);
    return res.status(500).json({ message: "Internal server error" });
  }
}

//this is the api for filter the data month wise for settled date


export const SettledDatefilterMonthwise = async (req, res) => {
  try {
    const { month, agentId } = req.query;

    if (!month || !agentId) {
      return res.status(400).json({ success: false, message: "Month and agentId are required." });
    }

    const monthNumber = month.padStart(2, "0"); // Ensure month is in "MM" format
    const objectIdAgentId = new mongoose.Types.ObjectId(agentId); // Convert agentId to ObjectId

    // Define filter to match the settlement month
    const filter = {
      agent_Id: objectIdAgentId,
      settlement_status: true,
      Daily_wages: { $gt: 0 },
      settlement_date: { $regex: `^\\d{2}-${monthNumber}-\\d{4}$` }, // Match "DD-MM-YYYY"
    };

    // if(!month){
    //   const all_data=await agentData.
    // }

    // Fetch settlements based on the filter
    const settlements = await agentData.find(filter).sort({ settlement_date: -1 }).exec();

    if (settlements.length === 0) {
      return res.json({ success: true, message: "No data found for the selected month.", data: [] });
    }

    // Find the latest settlement date
    const latestDate = settlements[0].settlement_date;

    // Filter settlements for the latest date
    const latestSettlements = settlements.filter((settlement) => settlement.settlement_date === latestDate);
    const totalAmount = latestSettlements.reduce((sum, settlement) => sum + settlement.Daily_wages, 0);

    // Group data by `settlement_date`
    const groupedData = {};

    settlements.forEach((record) => {
      const date = record.settlement_date; // Get settlement date

      if (!groupedData[date]) {
        groupedData[date] = {
          settlement_date: date,
          totalAmount: 0,
        };
      }

      // Convert Daily_wages safely
      const dailyWages = parseFloat(record.Daily_wages);
      groupedData[date].totalAmount += isNaN(dailyWages) ? 0 : dailyWages;
    });

    // Convert grouped object to an array and sort by `settlement_date` (latest first)
    const result = Object.values(groupedData).sort((a, b) => {
      return (
        new Date(b.settlement_date.split("-").reverse().join("-")) -
        new Date(a.settlement_date.split("-").reverse().join("-"))
      );
    });

    console.log(result);

    return res.status(200).json({
      message: "Last settlement found",
      lastSettlement: [
        {
          totalAmount: totalAmount,
          date: latestDate,
        },
      ],
      result: result,
    });
  } catch (error) {
    console.error("Error in SettledDatefilterMonthwise API:", error);
    return res.status(500).json({ success: false, message: "Internal Server Error" });
  }
};

//api for fetch the pending amount history and show in the table month wise
export const getPendingAmountHistoryByMonth = async (req, res) => {
  try {
    const { agentId, month } = req.query;

    if (!agentId) {
      return res.status(400).json({ success: false, message: "Agent ID is required." });
    }

    let filter = {
      agent_Id: agentId,
      Daily_wages: { $gt: 0 },
      settlement_status: false,
    };

    // If month is provided, add the month filter
    if (month) {
      const monthNumber = month.padStart(2, "0"); // Ensure "MM" format
      filter.Date = { $regex: `^\\d{2}-${monthNumber}-\\d{4}$` }; // Match "DD-MM-YYYY"
    }

    // Fetch pending payments (filtered or all)
    const agent_data = await agentData.find(filter).sort({ Date: -1 }).exec();

    if (!agent_data.length) {
      return res.json({ success: true, message: "No pending payment history found.", data: [] });
    }

    // Format data for frontend binding
    const filteredData = agent_data.map(record => ({
      _id: record._id,
      Date: record.Date,
      Daily_wages: record.Daily_wages,
    }));

    return res.status(200).json({
      success: true,
      message: "Pending payment history found",
      data: filteredData,
    });

  } catch (error) {
    console.error("Error in getPendingAmountHistoryByMonth API:", error);
    return res.status(500).json({ success: false, message: "Internal Server Error" });
  }
};

//api for fetch the amount according to the advance date
export const getAdvanceAmountbyDays=async(req,res)=>{
  try{
      
     const {days,agentId}=req.query;

     const agentData=await Users.findById(
      {_id:agentId}
     )
     const daily_wages=agentData.Daily_wages;
     const amount=parseInt(daily_wages*days);
     console.log("the amount for the day is",amount);
    if(amount){
      return res.status(200).json({success:true,message:"Amount for the day is",data:amount})
    }
    else{
      return res.status(500).json({success:false,message:"amount cant be calculated",data:0})
    }
  }catch(error){
    console.error("Error in getAdvanceAmountbyDays API:", error);
    return res.status(500).json({ success: false, message: "Internal Server Error"})
  }
}

//api for calculate the money for selected pending orders of the agent
export const calculatetotal=async(req,res)=>{
  try{
       const {agentId}=req.params;
       const  {paymentIds}=req.body;
       const get_payment_data = await agentData.find({
        agent_Id: agentId,
        settlement_status: false,
         _id: { $in: paymentIds } 
      });
      
      let totalAmount = get_payment_data.reduce((accumulator, currentItem) => {
        return accumulator + parseInt(currentItem.Daily_wages, 10);
      }, 0);
      
      console.log("Total Daily Wages:", totalAmount);
      if (totalAmount) {
        return res.status(200).json({success:true,totalAmount});
      }
      else{
        return res.status(500).json({success:false,totalAmount:0})
      }
  }catch(error){
    console.error("Error in calculatetotal API:", error);
    return res.status(500).json({ success: false, message: "Internal Server Error"});
  }
}





  
  
  
