import mongoose from "mongoose";

const itemSchema = mongoose.Schema({
    itemid: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'items',
    },
    weight: {
        type: Number,
    },
    item_name: {
        type: String,
    },
    price: {
        type: Number,
    },
    total: {
        type: Number,
    },
    unit: {
        type: String,
    },
    isActive: {
        type: Number,
    }
    // imageURL: String,
});

const orderSchema = mongoose.Schema({
    customer_id: {
        type: mongoose.Schema.Types.ObjectId, // Assuming you're using Mongoose
        ref: 'customers',
    },
    address_id: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'address',
    },
    agent_id: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'users',
    },
    item: [
        itemSchema
    ],
    pout: {
        type: String,
    },
    mode: {
        type: String,
    },
    payment_id: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'paymentdetails',
    },
    // item: [{
    //     itemid: {
    //         type: mongoose.Schema.Types.ObjectId,
    //         ref: 'items',
    //     },
    //     weight: {
    //         type: Number,
    //     }
    // }],
    est_price: {
        type: Number
    },
    order_id: {
        type: String
    },
    schedule_date: {
        type: String
    },
    time: {
        type: String
    },
    isAssign: {
        type: Boolean
    },
    status: {
        type: String,
        default: 'Created'
    },
    reason: String,
    // isActive: {
    //     type:Boolean,
    //     default:true
    // },
    isDelete: {
        type: Number,
        default: 0
    },
    recursive_ord: {
        type: Boolean,
    },
    transctionId: {
        type: String,
    },
    notes: {
        type: String,
    },
    settlement_date: {
        type: String,
    },
    payment_settlement: {
        type: String,
    },
    scheduleDateForLastOrder: {
        type: String,
    },
    pickupday: {
        type: String,
    },
    recursive_orderid: {
        type: mongoose.Schema.Types.ObjectId,
    }
}, {
    timestamps: true
});

const Orders = mongoose.model("orders", orderSchema);
export default Orders;
